/*
 *  option.h
 *  Copyright (C) 1998,1999 SAKAI Katsuya
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __OPTION_H_
#define __OPTION_H_

#include <sys/types.h>
#include "config.h"

class OPTION {
public:
  OPTION();
  ~OPTION(){
	if(Data!=0) delete Data;
  }
  
  void getOption(int, char **);
  void shuffleData();

  void setIndexToHead(){ Index=0; }
  void setIndexToPrevData() {if(Index<2) Index=0; else Index-=2;}
  char *NextData(){
	if(Index>=NumOfData) return NULL;
	else return Data[Index++];
  }

  char shuffle;
  char **Data;
  u_char PortAdevice;
  u_char PortBdevice;
  u_char PortCdevice;
  u_char PortDdevice;
  u_char PortEdevice;
  u_char PortFdevice;

  u_char useSerial;
  u_char Output;
  u_char changeBank32;
  char SerialDevice[256];
  char SequencerDevice[256];
  char ResetDataName[256];
  u_long NumOfData;
  u_long repeat;
  u_long wait;
  u_short tempo;

  char *filename(char *);

protected:
  void usage();

  u_long readDec(char *);
  void   readDec(char *, u_long *, u_long *);
  char *progname;
  u_long Index;
};

#endif
