/*
 *  queue.h
 *  Copyright (C) 1998,1999 SAKAI Katsuya
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _EVENT_QUEUE_H
#define _EVENT_QUEUE_H

#include <sys/types.h>
#include <iostream.h>

class Event {
public:
  u_char Track;
  u_long Time;
  u_char Type;

  u_char Channel;
  u_char Note;
  u_char Port;
};

class Event_Queue_Base {
public:
  virtual u_long NextTime()=0;
  virtual Event *retrieve()=0;
  virtual Event *store(Event *)=0;
};


// ٥ȥ塼(ץ饤ƥ塼)
#define MAX_QUEUE_LENGTH 256
class EventQueue : Event_Queue_Base {
public:
  virtual u_long NextTime();
  virtual Event *retrieve();
  virtual Event *store(Event *);

  EventQueue(){
	Max = MAX_QUEUE_LENGTH;
	item = 0;
  }
  virtual ~EventQueue(){
	Event *ev;
	while((ev=retrieve())!=NULL)
	  {
		delete ev;
	  }
  }

protected:
  u_long Max;
  u_long item;
  Event *queue[MAX_QUEUE_LENGTH];
  Event *min(Event *, Event *, Event *);
};

#endif
