/*
 *  seq_oss_sio.h
 *  Copyright (C) 1998,1999 SAKAI Katsuya
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SEQ_OSS_SERIAL_H_
#define __SEQ_OSS_SERIAL_H_

#include <iostream.h>
#include <sys/types.h>
#include <sys/time.h>
#include <termios.h>

#include "config.h"

#include "seq_serial.h"

class Seq_OSS_Serial : public Sequencer_Serial {
public:
  Seq_OSS_Serial(){
	_buf=NULL; flagOpen=0; numberOfDevice=0;
  }
  virtual int open(char *, int);
  virtual int close();
  virtual int checkMidiDevice();

  virtual void reset();

  virtual void startTimer();
  virtual void stopTimer();
  virtual void MidiOut(u_char, char);
  virtual void midiEvent1(u_char port, u_char ev, u_char para1);
  virtual void midiEvent2(u_char port, u_char ev, u_char para1, u_char para2);
  virtual void send_exclusive(u_char port, u_char *ex, int len);

protected:
  int midifd[10];
  u_char SIOPORT[16]; 
  u_char **_buf;
  int *_bufptr;

  virtual void seq_midiout(u_char dev, u_char dat);
  virtual void seq_waittime(u_long);
  virtual void seqbuf_dump();
};

#endif
