/*
 *  seq_serial.h
 *  Copyright (C) 1998,1999 SAKAI Katsuya
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SEQUENCER_SERIAL_H_
#define __SEQUENCER_SERIAL_H_

#include <iostream.h>
#include <sys/types.h>
#include <sys/time.h>
#include <termios.h>

#include "config.h"

#include "sequencer.h"

class Sequencer_Serial : public Sequencer {
public:
  Sequencer_Serial(){
	_seqbuf=NULL; flagOpen=0; numberOfDevice=0;
  }
  virtual int open(char *, int);
  virtual int close();
  virtual int checkMidiDevice();

  virtual void reset();
  virtual void sync();

  virtual void startTimer();
  virtual void stopTimer();

protected:
  virtual void seq_midiout(u_char dev, u_char dat);
  virtual void seq_waittime(u_long);

  termios tio_orig;
  timeval starttime, now;
};

#endif
