/*
 *  seq_smf0.h
 *  Copyright (C) 1998,1999 SAKAI Katsuya
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SEQUENCER_SMF0_H_
#define __SEQUENCER_SMF0_H_

#include <iostream.h>
#include <sys/types.h>
#include <sys/time.h>

#include "config.h"

#include "sequencer.h"

class Sequencer_SMF0 : public Sequencer {
public:
  Sequencer_SMF0(){
	_seqbuf=NULL; flagOpen=0; numberOfDevice=0;
  }
  virtual int open(char *, int);
  virtual int close();
  virtual int checkMidiDevice();
  virtual void AllNoteOff(u_char dev);

  virtual void reset();
  virtual void sync();

  virtual void startTimer();
  virtual void stopTimer();
  virtual void waitTime(u_long);
  /*  virtual void MidiOut(u_char, char);*/

  virtual void midiEvent1(u_char port, u_char ev, u_char para1);
  virtual void midiEvent2(u_char port, u_char ev, u_char para1, u_char para2);
  virtual void send_exclusive (u_char port, u_char *ex, int len);
  virtual void metaEvent(u_char type, int len, char *data);

#ifdef RUNNING_ST
  virtual void clearStatus(u_char dev);
#endif
  virtual void set_tempo(u_long);

protected:
  u_long Tick;
  char tempoflag;
  
  void seq_midiout (u_char);
  void write_tick();
  void write_string(char *);
  void write_varlen(long);
  void write_conlen(long, u_char);
  virtual void changePort(u_char , u_char);  // serial connection
};

#endif
